/*
 * generated by Xtext 2.26.0.M2
 */
package inf225.parser;

import com.google.inject.Inject;
import com.google.inject.Singleton;
import java.util.List;
import org.eclipse.xtext.Alternatives;
import org.eclipse.xtext.Assignment;
import org.eclipse.xtext.Grammar;
import org.eclipse.xtext.GrammarUtil;
import org.eclipse.xtext.Group;
import org.eclipse.xtext.Keyword;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.RuleCall;
import org.eclipse.xtext.TerminalRule;
import org.eclipse.xtext.common.services.TerminalsGrammarAccess;
import org.eclipse.xtext.service.AbstractElementFinder;
import org.eclipse.xtext.service.GrammarProvider;

@Singleton
public class RoboSpeakGrammarAccess extends AbstractElementFinder.AbstractGrammarElementFinder {
	
	public class ModelElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.inf225.RoboSpeak.Model");
		private final Assignment cMovesAssignment = (Assignment)rule.eContents().get(1);
		private final RuleCall cMovesCommandParserRuleCall_0 = (RuleCall)cMovesAssignment.eContents().get(0);
		
		//Model :
		//    moves+=command*
		//;
		@Override public ParserRule getRule() { return rule; }
		
		//moves+=command*
		public Assignment getMovesAssignment() { return cMovesAssignment; }
		
		//command
		public RuleCall getMovesCommandParserRuleCall_0() { return cMovesCommandParserRuleCall_0; }
	}
	public class CommandElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.inf225.RoboSpeak.command");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final RuleCall cManeuverParserRuleCall_0 = (RuleCall)cAlternatives.eContents().get(0);
		private final RuleCall cANDParserRuleCall_1 = (RuleCall)cAlternatives.eContents().get(1);
		
		//command :
		//    Maneuver
		//;
		@Override public ParserRule getRule() { return rule; }
		
		//Maneuver
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//Maneuver
		public RuleCall getManeuverParserRuleCall_0() { return cManeuverParserRuleCall_0; }
		
		//AND
		public RuleCall getANDParserRuleCall_1() { return cANDParserRuleCall_1; }
	}
	public class ManeuverElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.inf225.RoboSpeak.Maneuver");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final RuleCall cMineParserRuleCall_0 = (RuleCall)cAlternatives.eContents().get(0);
		private final RuleCall cMoveParserRuleCall_1 = (RuleCall)cAlternatives.eContents().get(1);
		
		//Maneuver :
		//    Mine | Move
		//;
		@Override public ParserRule getRule() { return rule; }
		
		//Mine | Move
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//Mine
		public RuleCall getMineParserRuleCall_0() { return cMineParserRuleCall_0; }
		
		//Move
		public RuleCall getMoveParserRuleCall_1() { return cMoveParserRuleCall_1; }
	}
	public class MineElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.inf225.RoboSpeak.Mine");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cMineKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final RuleCall cDirectionParserRuleCall_1 = (RuleCall)cGroup.eContents().get(1);
		
		//Mine :
		//    'Mine' direction
		//;
		@Override public ParserRule getRule() { return rule; }
		
		//'Mine' direction
		public Group getGroup() { return cGroup; }
		
		//'Mine'
		public Keyword getMineKeyword_0() { return cMineKeyword_0; }
		
		//direction
		public RuleCall getDirectionParserRuleCall_1() { return cDirectionParserRuleCall_1; }
	}
	public class MoveElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.inf225.RoboSpeak.Move");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cMoveKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Assignment cDistAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final RuleCall cDistINTTerminalRuleCall_1_0 = (RuleCall)cDistAssignment_1.eContents().get(0);
		private final RuleCall cDirectionParserRuleCall_2 = (RuleCall)cGroup.eContents().get(2);
		
		//Move :
		//    'Move' dist=INT direction
		//;
		@Override public ParserRule getRule() { return rule; }
		
		//'Move' dist=INT direction
		public Group getGroup() { return cGroup; }
		
		//'Move'
		public Keyword getMoveKeyword_0() { return cMoveKeyword_0; }
		
		//dist=INT
		public Assignment getDistAssignment_1() { return cDistAssignment_1; }
		
		//INT
		public RuleCall getDistINTTerminalRuleCall_1_0() { return cDistINTTerminalRuleCall_1_0; }
		
		//direction
		public RuleCall getDirectionParserRuleCall_2() { return cDirectionParserRuleCall_2; }
	}
	public class DirectionElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.inf225.RoboSpeak.direction");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final Keyword cNorthKeyword_0 = (Keyword)cAlternatives.eContents().get(0);
		private final Keyword cEastKeyword_1 = (Keyword)cAlternatives.eContents().get(1);
		private final Keyword cSouthKeyword_2 = (Keyword)cAlternatives.eContents().get(2);
		private final Keyword cWestKeyword_3 = (Keyword)cAlternatives.eContents().get(3);
		
		//direction :
		//    'North' | 'East' | 'South' | 'West'
		//;
		@Override public ParserRule getRule() { return rule; }
		
		//'North' | 'East' | 'South' | 'West'
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//'North'
		public Keyword getNorthKeyword_0() { return cNorthKeyword_0; }
		
		//'East'
		public Keyword getEastKeyword_1() { return cEastKeyword_1; }
		
		//'South'
		public Keyword getSouthKeyword_2() { return cSouthKeyword_2; }
		
		//'West'
		public Keyword getWestKeyword_3() { return cWestKeyword_3; }
	}
	public class ANDElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.inf225.RoboSpeak.AND");
		private final Keyword cANDKeyword = (Keyword)rule.eContents().get(1);
		
		//AND :
		//    'AND'
		//;
		@Override public ParserRule getRule() { return rule; }
		
		//'AND'
		public Keyword getANDKeyword() { return cANDKeyword; }
	}
	
	
	private final ModelElements pModel;
	private final CommandElements pCommand;
	private final ManeuverElements pManeuver;
	private final MineElements pMine;
	private final MoveElements pMove;
	private final DirectionElements pDirection;
	private final ANDElements pAND;
	
	private final Grammar grammar;
	
	private final TerminalsGrammarAccess gaTerminals;

	@Inject
	public RoboSpeakGrammarAccess(GrammarProvider grammarProvider,
			TerminalsGrammarAccess gaTerminals) {
		this.grammar = internalFindGrammar(grammarProvider);
		this.gaTerminals = gaTerminals;
		this.pModel = new ModelElements();
		this.pCommand = new CommandElements();
		this.pManeuver = new ManeuverElements();
		this.pMine = new MineElements();
		this.pMove = new MoveElements();
		this.pDirection = new DirectionElements();
		this.pAND = new ANDElements();
	}
	
	protected Grammar internalFindGrammar(GrammarProvider grammarProvider) {
		Grammar grammar = grammarProvider.getGrammar(this);
		while (grammar != null) {
			if ("org.inf225.RoboSpeak".equals(grammar.getName())) {
				return grammar;
			}
			List<Grammar> grammars = grammar.getUsedGrammars();
			if (!grammars.isEmpty()) {
				grammar = grammars.iterator().next();
			} else {
				return null;
			}
		}
		return grammar;
	}
	
	@Override
	public Grammar getGrammar() {
		return grammar;
	}
	
	
	public TerminalsGrammarAccess getTerminalsGrammarAccess() {
		return gaTerminals;
	}

	
	//Model :
	//    moves+=command*
	//;
	public ModelElements getModelAccess() {
		return pModel;
	}
	
	public ParserRule getModelRule() {
		return getModelAccess().getRule();
	}
	
	//command :
	//    Maneuver | AND
	//;
	public CommandElements getCommandAccess() {
		return pCommand;
	}
	
	public ParserRule getCommandRule() {
		return getCommandAccess().getRule();
	}
	
	//Maneuver :
	//    Mine | Move
	//;
	public ManeuverElements getManeuverAccess() {
		return pManeuver;
	}
	
	public ParserRule getManeuverRule() {
		return getManeuverAccess().getRule();
	}
	
	//Mine :
	//    'Mine' direction
	//;
	public MineElements getMineAccess() {
		return pMine;
	}
	
	public ParserRule getMineRule() {
		return getMineAccess().getRule();
	}
	
	//Move :
	//    'Move' dist=INT direction
	//;
	public MoveElements getMoveAccess() {
		return pMove;
	}
	
	public ParserRule getMoveRule() {
		return getMoveAccess().getRule();
	}
	
	//direction :
	//    'North' | 'East' | 'South' | 'West'
	//;
	public DirectionElements getDirectionAccess() {
		return pDirection;
	}
	
	public ParserRule getDirectionRule() {
		return getDirectionAccess().getRule();
	}
	
	//AND :
	//    'AND'
	//;
	public ANDElements getANDAccess() {
		return pAND;
	}
	
	public ParserRule getANDRule() {
		return getANDAccess().getRule();
	}
	
	//terminal ID: '^'?('a'..'z'|'A'..'Z'|'_') ('a'..'z'|'A'..'Z'|'_'|'0'..'9')*;
	public TerminalRule getIDRule() {
		return gaTerminals.getIDRule();
	}
	
	//terminal INT returns ecore::EInt: ('0'..'9')+;
	public TerminalRule getINTRule() {
		return gaTerminals.getINTRule();
	}
	
	//terminal STRING:
	//            '"' ( '\\' . /* 'b'|'t'|'n'|'f'|'r'|'u'|'"'|"'"|'\\' */ | !('\\'|'"') )* '"' |
	//            "'" ( '\\' . /* 'b'|'t'|'n'|'f'|'r'|'u'|'"'|"'"|'\\' */ | !('\\'|"'") )* "'"
	//        ;
	public TerminalRule getSTRINGRule() {
		return gaTerminals.getSTRINGRule();
	}
	
	//terminal ML_COMMENT : '/*' -> '*/';
	public TerminalRule getML_COMMENTRule() {
		return gaTerminals.getML_COMMENTRule();
	}
	
	//terminal SL_COMMENT : '//' !('\n'|'\r')* ('\r'? '\n')?;
	public TerminalRule getSL_COMMENTRule() {
		return gaTerminals.getSL_COMMENTRule();
	}
	
	//terminal WS         : (' '|'\t'|'\r'|'\n')+;
	public TerminalRule getWSRule() {
		return gaTerminals.getWSRule();
	}
	
	//terminal ANY_OTHER: .;
	public TerminalRule getANY_OTHERRule() {
		return gaTerminals.getANY_OTHERRule();
	}
}

